<?php

/*******************************************************************
* shoutcast.class.php
* Version: 0.1
* Author: Henrik Malmberg
* Copyright (C) 2002, Henrik Malmberg
* henrik@ih.nut
* http://yoda.ih.nu/
*
*******************************************************************
This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*******************************************************************/

/*
   2017 - v2 DNAS mods by djSpinnerCee - christopher.walker.11423@gmail.com
   cjw - http://djspinnercee.servemp3.com:11423/scStatus.html
*/

class ShoutCast {
        // Public
        var $host;
        var $port;
        var $passwd;
        var $sid;   /* sid is needed for v2, =0 for v1 [cjw]*/

        //Private
        var $_xml;
        var $_error;

        function openstats() {
                $fp = fsockopen($this->host, $this->port, $errno, $errstr, 10);
                if (!$fp) {
                        $this->_error = "$errstr ($errno)";
                        return(0);
                } else {
                    /* for V2, add sid to url [cjw] */
                    if ($this->sid==0)
                       fputs($fp, "GET /admin.cgi?pass=".$this->passwd."&mode=viewxml HTTP/1.0\r\n");
                    else
                       fputs($fp, "GET /admin.cgi?sid=".$this->sid."&pass=".$this->passwd."&mode=viewxml HTTP/1.1\r\n");
                    fputs($fp, "User-Agent: Mozilla\r\n\r\n");
                    while (!feof($fp)) {
                                $this->_xml .= fgets($fp, 512);
                    }

                    fclose($fp);
//                  uncomment to dump xml as html comment for debugging [cjw]
//                    echo "\n<!--\n".$this->_xml."\n-->\n";

					
					     ///////////////////////////////
					//// Added by Gavin @ MixStream.net /////
					 $this->_xml = utf8_encode($this->_xml);
					/////////////////////////////////////////
					     ///////////////////////////////

                        if (stristr($this->_xml, "200 OK") == true) {
//                          if ($this->sid==0) {
                            // <-H> Thanks to Blaster for this fix.. trim();
//                            $this->_xml = trim(substr($this->_xml, 42));
//                          } else {
//                      this strips http headers ... [cjw]
                            $xxp=strpos($this->_xml,"<");
                            $this->_xml = trim(substr($this->_xml, $xxp));
//                          }
                        } else {
                                $this->_error = "Bad login";
                                return(0);
                        }

                        $xmlparser = xml_parser_create();
                        if (!xml_parse_into_struct($xmlparser, $this->_xml, $this->_values, $this->_indexes)) {
                                $this->_error = "Unparsable XML";
                                return(0);
                        }

                        xml_parser_free($xmlparser);

                        return(1);
                }
        }

        function GetCurrentListenersCount() {
                return($this->_values[$this->_indexes["CURRENTLISTENERS"][0]]["value"]);
        }

        function GetPeakListenersCount() {
                return($this->_values[$this->_indexes["PEAKLISTENERS"][0]]["value"]);
        }

        function GetMaxListenersCount() {
                return($this->_values[$this->_indexes["MAXLISTENERS"][0]]["value"]);
        }

        function GetReportedListenersCount() {
                return($this->_values[$this->_indexes["REPORTEDLISTENERS"][0]]["value"]);
        }

        function GetAverageListenTime() {
                return($this->_values[$this->_indexes["AVERAGETIME"][0]]["value"]);
        }

        function GetServerGenre() {
                return($this->_values[$this->_indexes["SERVERGENRE"][0]]["value"]);
        }

        function GetServerURL() {
                return($this->_values[$this->_indexes["SERVERURL"][0]]["value"]);
        }

        function GetServerTitle() {
                return($this->_values[$this->_indexes["SERVERTITLE"][0]]["value"]);
        }

        function GetCurrentSongTitle() {
                return($this->_values[$this->_indexes["SONGTITLE"][0]]["value"]);
        }

        function GetIRC() {
                return($this->_values[$this->_indexes["IRC"][0]]["value"]);
        }

        function GetAIM() {
                return($this->_values[$this->_indexes["AIM"][0]]["value"]);
        }

        function GetICQ() {
                return($this->_values[$this->_indexes["ICQ"][0]]["value"]);
        }

        function GetWebHitsCount() { // the v2 dnas no longer has webhits [cjw]
             if($this->sid>0)
                return("n/a");
             else
                return($this->_values[$this->_indexes["WEBHITS"][0]]["value"]);
        }

        function GetStreamHitsCount() {
                return($this->_values[$this->_indexes["STREAMHITS"][0]]["value"]);
        }

        function GetStreamStatus() {
                return($this->_values[$this->_indexes["STREAMSTATUS"][0]]["value"]);
        }

        function GetBitRate() {
                return($this->_values[$this->_indexes["BITRATE"][0]]["value"]);
        }

        function GetSongHistory() {
                for($i=1;$i<sizeof($this->_indexes['TITLE']);$i++) {
                        $arrhistory[$i-1] = array(
                        "playedat"=>$this->_values[$this->_indexes['PLAYEDAT'][$i]]['value'],
                        "title"=>$this->_values[$this->_indexes['TITLE'][$i]]['value']
                        );
                }

                return($arrhistory);
        }

        function GetListeners() { // the v2 listener table does not track underruns and pointer [cjw]
                for($i=0;$i<sizeof($this->_indexes['USERAGENT']);$i++) {
                    if($this->sid>0){
                        $arrlisteners[$i] = array(
                          "uid"=>$this->_values[$this->_indexes['UID'][$i]]['value'],
                          "hostname"=>$this->_values[$this->_indexes['HOSTNAME'][$i]]['value'],
                          "useragent"=>$this->_values[$this->_indexes['USERAGENT'][$i]]['value'],
                          "underruns"=>"n/a",
                          "connecttime"=>$this->_values[$this->_indexes['CONNECTTIME'][$i]]['value'],
                          "pointer"=>"n/a",
                          );
                     } else {
                        $arrlisteners[$i] = array(
                          "uid"=>$this->_values[$this->_indexes['UID'][$i]]['value'],
                          "hostname"=>$this->_values[$this->_indexes['HOSTNAME'][$i]]['value'],
                          "useragent"=>$this->_values[$this->_indexes['USERAGENT'][$i]]['value'],
                          "underruns"=>$this->_values[$this->_indexes['UNDERRUNS'][$i]]['value'],
                          "connecttime"=>$this->_values[$this->_indexes['CONNECTTIME'][$i]]['value'],
                          "pointer"=>$this->_values[$this->_indexes['POINTER'][$i]]['value'],
                          );
                     }
                }

                return($arrlisteners);
        }

        function geterror() { return($this->_error); }
}

?>